#=============================================================
#
#	PIPES.MAK
#
#=============================================================

.AUTODEPEND

#=============================================================
#		Translator Definitions
#=============================================================
CC = bcc +PIPES.CFG
TASM = tasm.exe
TLIB = tlib.exe
TLINK = tlink
RC = brcc.exe
RB = rc.exe
LIBPATH = C:\BCOS2\LIB
INCLUDEPATH = C:\BCOS2\INCLUDE;


#=============================================================
#		Implicit Rules
#=============================================================
.c.obj:
  $(CC) -c {$< }

.cpp.obj:
  $(CC) -c {$< }

.asm.obj:
  $(TASM) -Mx $*.asm,$*.obj

.rc.res:
  $(RC) -r $*.rc

#=============================================================
#		List Macros
#=============================================================


EXE_DEPENDENCIES =  \
 ctmutex.obj \
 mtration.obj \
 pipes.obj \
 genexc.obj \
 rational.obj

#=============================================================
#		Explicit Rules
#=============================================================
pipes.exe: pipes.cfg $(EXE_DEPENDENCIES)
  $(TLINK) /v /Toe /ap /L$(LIBPATH) @&&|
C:\BCOS2\LIB\C02.OBJ+
ctmutex.obj+
mtration.obj+
pipes.obj+
genexc.obj+
rational.obj
pipes,pipes
C:\BCOS2\LIB\C2.LIB+
C:\BCOS2\LIB\OS2.LIB

|


#=============================================================
#		Individual File Dependencies
#=============================================================
CTMUTEX.obj: pipes.cfg CTMUTEX.CPP 

MTRATION.obj: pipes.cfg ..\MTRATION.CPP 
	$(CC) -c ..\MTRATION.CPP

PIPES.obj: pipes.cfg PIPES.CPP 

GENEXC.obj: pipes.cfg ..\GENEXC.CPP
	$(CC) -c ..\GENEXC.CPP

RATIONAL.obj: pipes.cfg ..\RATIONAL.CPP
	$(CC) -c ..\RATIONAL.CPP

#=============================================================
#		Compiler Configuration File
#=============================================================
pipes.cfg: pipes.mak
  copy &&|
-D__MINMAX_DEFINED
-L$(LIBPATH)
-I$(INCLUDEPATH)
-vi-
| pipes.cfg


