#include "qprocess.h"
#include "ctmutex.h"

class calculator : public query_processor{
protected:
   double Result;
   double processOperator(expression_component Operation);
public:
  calculator(String Input);
  calculator(String Input,VSet VOperands,
				VSet VOperators,
				VSet VFunctions,
				VSet VCharacters,
				VSet VLetters,
				VSet VNumbers);

  calculator(void);
  double result(void);
  void processCloseParenthesis(void);
  void evaluate(void);
};


class mt_calculator : private mutex{
private:
   calculator Calculator;
public:
   double evaluate(String Input);
   list<expression_component> parse(String Input);
};

class threaded_calculator : private mutex{
private:
   String InputString;
   double Result;
    list<expression_component> Tokens;
public:
    threaded_calculator(void);
    friend void *evaluate(void *X);
    friend void *parse(void *X);
    double evaluate(String Input);
    list<expression_component> parse(String Input);
};    




