#include <set.h>
#include <vector.h>
#include <String.h>
#include <list.h>
#include <stack.h>
#include <express.h>


typedef set<char,less<char> > VSet;

class query_processor{
protected:
   set<char,less<char> > ValidOperands;
   set<char,less<char> > ValidOperators;
   set<String,less<String> > ValidFunctions;
   set<char,less<char> > ValidCharacters;
   set<char,less<char> > ValidLetters;
   set<char,less<char> > ValidNumbers;
   String InputString;
   list<expression_component> ExpressionTokens;
   stack<vector<expression_component> > OperandStack;
   stack<vector<expression_component> > OperatorStack;
   int ValidExpression;
   char FunctionResult[10];
public:
   query_processor(String Input);
   query_processor(String Input,VSet VOperands,
				VSet VOperators,
				VSet VFunctions,				VSet VCharacters,
				VSet VLetters,
				VSet VNumbers);

   query_processor(void);
   int checkParenthesis(void);
   int checkOperators(void); 
   int checkDecimals(void);
   int checkCharacters(void);
   virtual void evaluate(void) = 0;
   int parse(void);
   String inputString(void);
   void inputString(String Input);
   int validExpression(void);
   double processNumber(int &Count);
   char *processFunction(int &Count);
   list<expression_component> expressionToken(void);
   void process(void);
   int validate(void);
};

